/*
 *  data.c - counts the data exchanged
 *
 *  Robert Cheramy <tibob@via.ecp.fr>, 1999
 *
 */

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <ctype.h>
/* needed by F/BSD for <netinet/ip> */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>

#include <netinet/ip.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <stdio.h>
#include "utils.h"
#include "data.h"


struct s_data *p_data = NULL;

void data_add(__u32 ip, int in, int out) {
  struct s_data *p_datatmp;

  if (p_data == NULL || p_data->ip > ip) {
    //    p_datatmp = p_data;
    p_datatmp = malloc(sizeof(struct s_data));
    p_datatmp->prev = NULL;
    /* p_datatmp is NULL or a value, and there is no need for an if here*/
    p_datatmp->next = p_data;
    p_datatmp->ip = ip;
    p_datatmp->in = in;
    p_datatmp->out = out;
    if (p_data != NULL) {
      p_data->prev = p_datatmp;
    }
    p_data=p_datatmp;

  } else {
    for (p_datatmp = p_data; (p_datatmp->next != NULL) && (p_datatmp->ip < ip); p_datatmp = p_datatmp->next);

    if (p_datatmp->ip == ip) {
      p_datatmp->in += in;
      p_datatmp->out += out;

    } else if (p_datatmp->next == NULL && p_datatmp->ip < ip) {
      p_datatmp->next = malloc(sizeof(struct s_data));
      p_datatmp->next->prev = p_datatmp;
      p_datatmp->next->next = NULL;
      p_datatmp->next->ip = ip;
      p_datatmp->next->in = in;
      p_datatmp->next->out = out;
    } else {
      /*  if (p_datatmp->next == NULL && p_datatmp->ip > ip) {
or p_datatmp->ip > ip && p_datatmp !=NULL) */
      p_datatmp->prev->next = malloc(sizeof(struct s_data));
      p_datatmp->prev->next->prev = p_datatmp->prev;
      p_datatmp->prev->next->next = p_datatmp;
      p_datatmp->prev->next->ip = ip;
      p_datatmp->prev->next->in = in;
      p_datatmp->prev->next->out = out;
      p_datatmp->prev = p_datatmp->prev->next;
    }
  }
}

void data_flush(char *filename) {
  FILE *logfile;

  /* replace file */
  printf("Printing in %s\n", filename);
  logfile = fopen(filename, "w");
  if (logfile == NULL) {
    printf("Error opening log file. Exiting.\n");
    exit(1);
  }
  fprintf(logfile, "host\t\t\tIN\tOUT\tTOTAL\t\n");
  while (p_data != NULL) {
    fprintf (logfile, "%d.%d.%d.%d\t\t%ld\t%ld\t%ld\n", p_data->ip & 0xFF, (p_data->ip >> 8) & 0xFF, (p_data->ip >> 16) & 0xFF, (p_data->ip >> 24) & 0xFF,  p_data->in,  p_data->out,  p_data->in + p_data->out);
    /* Do not forget to free tables */
    if (p_data->next != NULL) {
      p_data = p_data->next;
      free(p_data->prev);
      p_data->prev = NULL;
    } else {
      p_data = NULL;
    }
  }
  fprintf(logfile, "\n");
  fclose(logfile);
}
